#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define LENGTH 50
#define NUMBER_OF_PEOPLE 5

enum gender {MALE, FEMALE};

struct name_forms
{
    char male_name[LENGTH], female_name[LENGTH];
} names[] = {{.male_name = "Andrzej", .female_name = "Anita"},
             {.male_name="Edward", .female_name="Katarzyna"},
             {.male_name="Henryk", .female_name="Magdalena"},
             {.male_name="Ireneusz", .female_name="Beata"},
             {.male_name="Jakub", .female_name="Joanna"}},

  surnames[] = {{.male_name="Kowalski", .female_name="Kowalska"},
                {.male_name="Zapolski", .female_name="Zapolska"},
                {.male_name="Sienkiewicz", .female_name="Orzeszkowa"},
                {.male_name="Żeromski", .female_name="Konopnicka"},
                {.male_name="Dąbrowski", .female_name="Potocka"}};

struct personal_data
{
    char name[LENGTH], surname[LENGTH];
    unsigned char age;
} people_data[NUMBER_OF_PEOPLE];


struct personal_data get_randomized_data(struct name_forms names[], struct name_forms surnames[])
{
   struct personal_data person;

   person.age = 1+rand()%120;
   unsigned char gender = rand()%2;
   if(gender==FEMALE) {
        strncpy(person.name,names[rand()%NUMBER_OF_PEOPLE].female_name,LENGTH-1);
        strncpy(person.surname,surnames[rand()%NUMBER_OF_PEOPLE].female_name,LENGTH-1);
   } else {
       strncpy(person.name,names[rand()%NUMBER_OF_PEOPLE].male_name,LENGTH-1);
       strncpy(person.surname,surnames[rand()%NUMBER_OF_PEOPLE].male_name,LENGTH-1);
   }
   return person;
}

void fill_array(struct personal_data array[], struct name_forms names[], struct name_forms surnames[])
{
    srand(time(0));
    int i;
    for(i=0;i<NUMBER_OF_PEOPLE;i++)
        array[i]=get_randomized_data(names, surnames);
}

void print_array(struct personal_data array[])
{
    int i;
    for(i=0;i<NUMBER_OF_PEOPLE;i++) {
        printf("Imię: %s\n",array[i].name);
        printf("Nazwisko: %s\n",array[i].surname);
        printf("Wiek: %u\n",array[i].age);
        puts("");
    }
}

int main(void)
{
    fill_array(people_data, names, surnames);
    print_array(people_data);
    return 0;
}
